#!/usr/bin/env node
import { inc as p, prerelease as S } from "semver";
import { join as h } from "node:path";
import { execSync as t } from "node:child_process";
import f from "pinyin";
import { readFileSync as u, existsSync as w } from "node:fs";
import c from "chalk";
const y = process.cwd(), v = "/.dc/publish.json", $ = "/package.json", b = ({ gitOriginName: o = "origin" }) => {
  try {
    const i = t("git rev-parse HEAD").toString().trim(), s = t('git log -1 --pretty=format:"%an"').toString().trim(), a = t('git log -1 --pretty=format:"%ae"').toString().trim(), r = t('git log -1 --pretty=format:"%s"').toString().trim(), n = t("git config user.name").toString().trim(), e = t("git config user.email").toString().trim(), g = t("git rev-parse --abbrev-ref HEAD").toString().trim();
    let l = "";
    try {
      l = t(`git config --get remote.${o}.url`).toString().trim();
    } catch {
      throw new Error(`git remote ${o} 不存在`);
    }
    return {
      lastHash: i,
      lastCommitter: s,
      lastCommitterPinYin: f(s, {
        style: f.STYLE_NORMAL,
        heteronym: !1
      }).join(""),
      lastCommitEmail: a,
      lastCommitMsg: r,
      userName: n,
      userNamePinYin: f(n, {
        style: f.STYLE_NORMAL,
        heteronym: !1
      }).join(""),
      userEmail: e,
      branchName: g,
      remoteUrl: l
    };
  } catch (i) {
    throw console.error("Error fetching git information:", i), i;
  }
}, d = async (o) => {
  const i = u(h(y, $), "utf-8"), s = JSON.parse(i);
  let a = s.name, r = "", n;
  const { version: e } = s;
  if (["major", "minor", "patch"].includes(o))
    r = p(e, o), n = "latest";
  else if (["premajor", "preminor", "prepatch"].includes(o)) {
    const g = S(e);
    g ? (console.log(
      c.yellow("当前版本已经是预发布版本，将会在当前版本基础上进行发布")
    ), g.length === 1 && typeof g[0] == "number" ? r = p(e, "prerelease") : r = e.split("-")[0] + "-0") : r = p(e, o), n = "next";
  } else
    n = "alpha", r = p(e, "prerelease", n);
  if (!r)
    throw new Error("version is empty");
  return {
    name: a,
    version: r,
    tag: n
  };
}, N = () => {
  let o;
  const i = h(y, v);
  if (w(i)) {
    const s = u(i, "utf-8");
    o = JSON.parse(s);
  } else
    console.log(
      c.yellow(`未找到配置文件，将使用默认配置
      { gitOriginName: "origin" }
    `)
    );
  return {
    gitOriginName: "origin",
    ...o || {}
  };
}, C = async (o, i) => {
  console.log("cmd:", o);
  const { type: s, push: a } = i, r = N(), n = b(r);
  console.log("type:", s), console.log("gitInfo:", n);
  const e = await d(s), { version: g } = e;
  console.log("npmInfo:", e), t(`npm version ${g} 1>&2`);
  try {
    if (o === "npm") {
      const { tag: l } = e;
      t(`npm publish --tag ${l} 1>&2`);
    } else if (o === "web") {
      const { webBuild: l } = r;
      l ? t(`${l} 1>&2`) : console.log(c.yellow("webBuild为空，不执行web构建"));
    } else
      throw new Error("未知命令");
  } catch (l) {
    console.log(c.red(`发布失败, error: ${l.message}`));
    try {
      console.log(
        c.blue(`回滚本地版本到发布前的版本：${n.lastHash}`)
      );
      const { lastHash: m } = n;
      t(`git reset --hard ${m} 1>&2`), console.log(c.blue(`删除本次发布时生成的tag：v${e.version}`)), t(`git tag -d v${e.version} 1>&2`);
    } catch (m) {
      console.log(c.red(`回滚失败, error: ${m.message}`));
    }
    return process.exit(1);
  }
  a && (t(`git push ${r.gitOriginName} v${e.version} 1>&2`), t(`git push ${r.gitOriginName} ${n.branchName} 1>&2`)), console.log(c.green("发布成功"));
};
export {
  C as handler
};
